//
// Copyright (C) 2022 Open Source Robotics Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

// Code generated by protoc-gen-go. DO NOT EDIT.
// versions:
// 	protoc-gen-go v1.28.1
// 	protoc        (unknown)
// source: domain/scenario.proto

package domain

import (
	protoreflect "google.golang.org/protobuf/reflect/protoreflect"
	protoimpl "google.golang.org/protobuf/runtime/protoimpl"
	durationpb "google.golang.org/protobuf/types/known/durationpb"
	timestamppb "google.golang.org/protobuf/types/known/timestamppb"
	reflect "reflect"
	sync "sync"
)

const (
	// Verify that this generated code is sufficiently up-to-date.
	_ = protoimpl.EnforceVersion(20 - protoimpl.MinVersion)
	// Verify that runtime/protoimpl is sufficiently up-to-date.
	_ = protoimpl.EnforceVersion(protoimpl.MaxVersion - 20)
)

type Scenario_Status int32

const (
	Scenario_UNKNOWN   Scenario_Status = 0
	Scenario_PENDING   Scenario_Status = 1000
	Scenario_SCHEDULED Scenario_Status = 2000
	Scenario_RUNNING   Scenario_Status = 3000
	Scenario_FINISHED  Scenario_Status = 4000
)

// Enum value maps for Scenario_Status.
var (
	Scenario_Status_name = map[int32]string{
		0:    "UNKNOWN",
		1000: "PENDING",
		2000: "SCHEDULED",
		3000: "RUNNING",
		4000: "FINISHED",
	}
	Scenario_Status_value = map[string]int32{
		"UNKNOWN":   0,
		"PENDING":   1000,
		"SCHEDULED": 2000,
		"RUNNING":   3000,
		"FINISHED":  4000,
	}
)

func (x Scenario_Status) Enum() *Scenario_Status {
	p := new(Scenario_Status)
	*p = x
	return p
}

func (x Scenario_Status) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (Scenario_Status) Descriptor() protoreflect.EnumDescriptor {
	return file_domain_scenario_proto_enumTypes[0].Descriptor()
}

func (Scenario_Status) Type() protoreflect.EnumType {
	return &file_domain_scenario_proto_enumTypes[0]
}

func (x Scenario_Status) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// Deprecated: Use Scenario_Status.Descriptor instead.
func (Scenario_Status) EnumDescriptor() ([]byte, []int) {
	return file_domain_scenario_proto_rawDescGZIP(), []int{0, 0}
}

// Scenario groups a set of tests executed by the testing library.
type Scenario struct {
	state         protoimpl.MessageState
	sizeCache     protoimpl.SizeCache
	unknownFields protoimpl.UnknownFields

	// Name contains the name of the scenario.
	Name string `protobuf:"bytes,1,opt,name=name,proto3" json:"name,omitempty"`
	// Description contains the description of the test results.
	Description string `protobuf:"bytes,2,opt,name=description,proto3" json:"description,omitempty"`
	// StartTime is the time point, in UTC epoch time, that this scenario started.
	StartTime *timestamppb.Timestamp `protobuf:"bytes,3,opt,name=start_time,json=startTime,proto3" json:"start_time,omitempty"`
	// Duration contains the duration that it took to run this scenario.
	Duration *durationpb.Duration `protobuf:"bytes,4,opt,name=duration,proto3" json:"duration,omitempty"`
	// IterationCount contains the total number of iterations that ran for this
	// scenario.
	IterationCount int32 `protobuf:"varint,5,opt,name=iteration_count,json=iterationCount,proto3" json:"iteration_count,omitempty"`
	// IterationFailCount contains the number of iterations that failed.
	IterationFailCount int32 `protobuf:"varint,6,opt,name=iteration_fail_count,json=iterationFailCount,proto3" json:"iteration_fail_count,omitempty"`
	// TestCount contains the total number of tests over all iterations
	// that ran for this scenario.
	TestCount int32 `protobuf:"varint,7,opt,name=test_count,json=testCount,proto3" json:"test_count,omitempty"`
	// TestFailCount contains the total number of failed tests over all
	// iterations that ran for this scenario.
	TestFailCount int32 `protobuf:"varint,8,opt,name=test_fail_count,json=testFailCount,proto3" json:"test_fail_count,omitempty"`
	// Iterations contains each iteration of the tests contained in the scenario.
	Iterations []*Iteration `protobuf:"bytes,9,rep,name=iterations,proto3" json:"iterations,omitempty"`
	// GroupId is a unique identifier for the simulation instance that produced
	// the test results.
	GroupId string `protobuf:"bytes,10,opt,name=group_id,json=groupId,proto3" json:"group_id,omitempty"`
	// Artifacts are set of links to the artifacts generated by this scenario.
	Artifacts []*Artifact `protobuf:"bytes,11,rep,name=artifacts,proto3" json:"artifacts,omitempty"`
	// Status contains the lifecycle state this scenario is in.
	Status Scenario_Status `protobuf:"varint,12,opt,name=status,proto3,enum=domain.Scenario_Status" json:"status,omitempty"`
	// Error contains an optional error message explaining why the scenario
	// failed. Error is empty if there are no errors with this scenario. It must
	// only be set if Scenario.Status == Finished.
	Error string `protobuf:"bytes,13,opt,name=error,proto3" json:"error,omitempty"`
	// Failed is true if any the iterations in this scenario failed.
	Failed bool `protobuf:"varint,14,opt,name=failed,proto3" json:"failed,omitempty"`
}

func (x *Scenario) Reset() {
	*x = Scenario{}
	if protoimpl.UnsafeEnabled {
		mi := &file_domain_scenario_proto_msgTypes[0]
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		ms.StoreMessageInfo(mi)
	}
}

func (x *Scenario) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Scenario) ProtoMessage() {}

func (x *Scenario) ProtoReflect() protoreflect.Message {
	mi := &file_domain_scenario_proto_msgTypes[0]
	if protoimpl.UnsafeEnabled && x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Scenario.ProtoReflect.Descriptor instead.
func (*Scenario) Descriptor() ([]byte, []int) {
	return file_domain_scenario_proto_rawDescGZIP(), []int{0}
}

func (x *Scenario) GetName() string {
	if x != nil {
		return x.Name
	}
	return ""
}

func (x *Scenario) GetDescription() string {
	if x != nil {
		return x.Description
	}
	return ""
}

func (x *Scenario) GetStartTime() *timestamppb.Timestamp {
	if x != nil {
		return x.StartTime
	}
	return nil
}

func (x *Scenario) GetDuration() *durationpb.Duration {
	if x != nil {
		return x.Duration
	}
	return nil
}

func (x *Scenario) GetIterationCount() int32 {
	if x != nil {
		return x.IterationCount
	}
	return 0
}

func (x *Scenario) GetIterationFailCount() int32 {
	if x != nil {
		return x.IterationFailCount
	}
	return 0
}

func (x *Scenario) GetTestCount() int32 {
	if x != nil {
		return x.TestCount
	}
	return 0
}

func (x *Scenario) GetTestFailCount() int32 {
	if x != nil {
		return x.TestFailCount
	}
	return 0
}

func (x *Scenario) GetIterations() []*Iteration {
	if x != nil {
		return x.Iterations
	}
	return nil
}

func (x *Scenario) GetGroupId() string {
	if x != nil {
		return x.GroupId
	}
	return ""
}

func (x *Scenario) GetArtifacts() []*Artifact {
	if x != nil {
		return x.Artifacts
	}
	return nil
}

func (x *Scenario) GetStatus() Scenario_Status {
	if x != nil {
		return x.Status
	}
	return Scenario_UNKNOWN
}

func (x *Scenario) GetError() string {
	if x != nil {
		return x.Error
	}
	return ""
}

func (x *Scenario) GetFailed() bool {
	if x != nil {
		return x.Failed
	}
	return false
}

var File_domain_scenario_proto protoreflect.FileDescriptor

var file_domain_scenario_proto_rawDesc = []byte{
	0x0a, 0x15, 0x64, 0x6f, 0x6d, 0x61, 0x69, 0x6e, 0x2f, 0x73, 0x63, 0x65, 0x6e, 0x61, 0x72, 0x69,
	0x6f, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x12, 0x06, 0x64, 0x6f, 0x6d, 0x61, 0x69, 0x6e, 0x1a,
	0x1f, 0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65, 0x2f, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75, 0x66,
	0x2f, 0x74, 0x69, 0x6d, 0x65, 0x73, 0x74, 0x61, 0x6d, 0x70, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f,
	0x1a, 0x1e, 0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65, 0x2f, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75,
	0x66, 0x2f, 0x64, 0x75, 0x72, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f,
	0x1a, 0x16, 0x64, 0x6f, 0x6d, 0x61, 0x69, 0x6e, 0x2f, 0x69, 0x74, 0x65, 0x72, 0x61, 0x74, 0x69,
	0x6f, 0x6e, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x1a, 0x15, 0x64, 0x6f, 0x6d, 0x61, 0x69, 0x6e,
	0x2f, 0x61, 0x72, 0x74, 0x69, 0x66, 0x61, 0x63, 0x74, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x22,
	0x83, 0x05, 0x0a, 0x08, 0x53, 0x63, 0x65, 0x6e, 0x61, 0x72, 0x69, 0x6f, 0x12, 0x12, 0x0a, 0x04,
	0x6e, 0x61, 0x6d, 0x65, 0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x52, 0x04, 0x6e, 0x61, 0x6d, 0x65,
	0x12, 0x20, 0x0a, 0x0b, 0x64, 0x65, 0x73, 0x63, 0x72, 0x69, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x18,
	0x02, 0x20, 0x01, 0x28, 0x09, 0x52, 0x0b, 0x64, 0x65, 0x73, 0x63, 0x72, 0x69, 0x70, 0x74, 0x69,
	0x6f, 0x6e, 0x12, 0x39, 0x0a, 0x0a, 0x73, 0x74, 0x61, 0x72, 0x74, 0x5f, 0x74, 0x69, 0x6d, 0x65,
	0x18, 0x03, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x1a, 0x2e, 0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65, 0x2e,
	0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75, 0x66, 0x2e, 0x54, 0x69, 0x6d, 0x65, 0x73, 0x74, 0x61,
	0x6d, 0x70, 0x52, 0x09, 0x73, 0x74, 0x61, 0x72, 0x74, 0x54, 0x69, 0x6d, 0x65, 0x12, 0x35, 0x0a,
	0x08, 0x64, 0x75, 0x72, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x18, 0x04, 0x20, 0x01, 0x28, 0x0b, 0x32,
	0x19, 0x2e, 0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75,
	0x66, 0x2e, 0x44, 0x75, 0x72, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x52, 0x08, 0x64, 0x75, 0x72, 0x61,
	0x74, 0x69, 0x6f, 0x6e, 0x12, 0x27, 0x0a, 0x0f, 0x69, 0x74, 0x65, 0x72, 0x61, 0x74, 0x69, 0x6f,
	0x6e, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x18, 0x05, 0x20, 0x01, 0x28, 0x05, 0x52, 0x0e, 0x69,
	0x74, 0x65, 0x72, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x43, 0x6f, 0x75, 0x6e, 0x74, 0x12, 0x30, 0x0a,
	0x14, 0x69, 0x74, 0x65, 0x72, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x5f, 0x66, 0x61, 0x69, 0x6c, 0x5f,
	0x63, 0x6f, 0x75, 0x6e, 0x74, 0x18, 0x06, 0x20, 0x01, 0x28, 0x05, 0x52, 0x12, 0x69, 0x74, 0x65,
	0x72, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x46, 0x61, 0x69, 0x6c, 0x43, 0x6f, 0x75, 0x6e, 0x74, 0x12,
	0x1d, 0x0a, 0x0a, 0x74, 0x65, 0x73, 0x74, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x18, 0x07, 0x20,
	0x01, 0x28, 0x05, 0x52, 0x09, 0x74, 0x65, 0x73, 0x74, 0x43, 0x6f, 0x75, 0x6e, 0x74, 0x12, 0x26,
	0x0a, 0x0f, 0x74, 0x65, 0x73, 0x74, 0x5f, 0x66, 0x61, 0x69, 0x6c, 0x5f, 0x63, 0x6f, 0x75, 0x6e,
	0x74, 0x18, 0x08, 0x20, 0x01, 0x28, 0x05, 0x52, 0x0d, 0x74, 0x65, 0x73, 0x74, 0x46, 0x61, 0x69,
	0x6c, 0x43, 0x6f, 0x75, 0x6e, 0x74, 0x12, 0x31, 0x0a, 0x0a, 0x69, 0x74, 0x65, 0x72, 0x61, 0x74,
	0x69, 0x6f, 0x6e, 0x73, 0x18, 0x09, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x11, 0x2e, 0x64, 0x6f, 0x6d,
	0x61, 0x69, 0x6e, 0x2e, 0x49, 0x74, 0x65, 0x72, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x52, 0x0a, 0x69,
	0x74, 0x65, 0x72, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x73, 0x12, 0x19, 0x0a, 0x08, 0x67, 0x72, 0x6f,
	0x75, 0x70, 0x5f, 0x69, 0x64, 0x18, 0x0a, 0x20, 0x01, 0x28, 0x09, 0x52, 0x07, 0x67, 0x72, 0x6f,
	0x75, 0x70, 0x49, 0x64, 0x12, 0x2e, 0x0a, 0x09, 0x61, 0x72, 0x74, 0x69, 0x66, 0x61, 0x63, 0x74,
	0x73, 0x18, 0x0b, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x10, 0x2e, 0x64, 0x6f, 0x6d, 0x61, 0x69, 0x6e,
	0x2e, 0x41, 0x72, 0x74, 0x69, 0x66, 0x61, 0x63, 0x74, 0x52, 0x09, 0x61, 0x72, 0x74, 0x69, 0x66,
	0x61, 0x63, 0x74, 0x73, 0x12, 0x2f, 0x0a, 0x06, 0x73, 0x74, 0x61, 0x74, 0x75, 0x73, 0x18, 0x0c,
	0x20, 0x01, 0x28, 0x0e, 0x32, 0x17, 0x2e, 0x64, 0x6f, 0x6d, 0x61, 0x69, 0x6e, 0x2e, 0x53, 0x63,
	0x65, 0x6e, 0x61, 0x72, 0x69, 0x6f, 0x2e, 0x53, 0x74, 0x61, 0x74, 0x75, 0x73, 0x52, 0x06, 0x73,
	0x74, 0x61, 0x74, 0x75, 0x73, 0x12, 0x14, 0x0a, 0x05, 0x65, 0x72, 0x72, 0x6f, 0x72, 0x18, 0x0d,
	0x20, 0x01, 0x28, 0x09, 0x52, 0x05, 0x65, 0x72, 0x72, 0x6f, 0x72, 0x12, 0x16, 0x0a, 0x06, 0x66,
	0x61, 0x69, 0x6c, 0x65, 0x64, 0x18, 0x0e, 0x20, 0x01, 0x28, 0x08, 0x52, 0x06, 0x66, 0x61, 0x69,
	0x6c, 0x65, 0x64, 0x22, 0x50, 0x0a, 0x06, 0x53, 0x74, 0x61, 0x74, 0x75, 0x73, 0x12, 0x0b, 0x0a,
	0x07, 0x55, 0x4e, 0x4b, 0x4e, 0x4f, 0x57, 0x4e, 0x10, 0x00, 0x12, 0x0c, 0x0a, 0x07, 0x50, 0x45,
	0x4e, 0x44, 0x49, 0x4e, 0x47, 0x10, 0xe8, 0x07, 0x12, 0x0e, 0x0a, 0x09, 0x53, 0x43, 0x48, 0x45,
	0x44, 0x55, 0x4c, 0x45, 0x44, 0x10, 0xd0, 0x0f, 0x12, 0x0c, 0x0a, 0x07, 0x52, 0x55, 0x4e, 0x4e,
	0x49, 0x4e, 0x47, 0x10, 0xb8, 0x17, 0x12, 0x0d, 0x0a, 0x08, 0x46, 0x49, 0x4e, 0x49, 0x53, 0x48,
	0x45, 0x44, 0x10, 0xa0, 0x1f, 0x42, 0x31, 0x5a, 0x2f, 0x67, 0x69, 0x74, 0x6c, 0x61, 0x62, 0x2e,
	0x63, 0x6f, 0x6d, 0x2f, 0x69, 0x67, 0x6e, 0x69, 0x74, 0x69, 0x6f, 0x6e, 0x72, 0x6f, 0x62, 0x6f,
	0x74, 0x69, 0x63, 0x73, 0x2f, 0x63, 0x6c, 0x6f, 0x75, 0x64, 0x73, 0x69, 0x6d, 0x2f, 0x61, 0x70,
	0x69, 0x2f, 0x64, 0x6f, 0x6d, 0x61, 0x69, 0x6e, 0x62, 0x06, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x33,
}

var (
	file_domain_scenario_proto_rawDescOnce sync.Once
	file_domain_scenario_proto_rawDescData = file_domain_scenario_proto_rawDesc
)

func file_domain_scenario_proto_rawDescGZIP() []byte {
	file_domain_scenario_proto_rawDescOnce.Do(func() {
		file_domain_scenario_proto_rawDescData = protoimpl.X.CompressGZIP(file_domain_scenario_proto_rawDescData)
	})
	return file_domain_scenario_proto_rawDescData
}

var file_domain_scenario_proto_enumTypes = make([]protoimpl.EnumInfo, 1)
var file_domain_scenario_proto_msgTypes = make([]protoimpl.MessageInfo, 1)
var file_domain_scenario_proto_goTypes = []interface{}{
	(Scenario_Status)(0),          // 0: domain.Scenario.Status
	(*Scenario)(nil),              // 1: domain.Scenario
	(*timestamppb.Timestamp)(nil), // 2: google.protobuf.Timestamp
	(*durationpb.Duration)(nil),   // 3: google.protobuf.Duration
	(*Iteration)(nil),             // 4: domain.Iteration
	(*Artifact)(nil),              // 5: domain.Artifact
}
var file_domain_scenario_proto_depIdxs = []int32{
	2, // 0: domain.Scenario.start_time:type_name -> google.protobuf.Timestamp
	3, // 1: domain.Scenario.duration:type_name -> google.protobuf.Duration
	4, // 2: domain.Scenario.iterations:type_name -> domain.Iteration
	5, // 3: domain.Scenario.artifacts:type_name -> domain.Artifact
	0, // 4: domain.Scenario.status:type_name -> domain.Scenario.Status
	5, // [5:5] is the sub-list for method output_type
	5, // [5:5] is the sub-list for method input_type
	5, // [5:5] is the sub-list for extension type_name
	5, // [5:5] is the sub-list for extension extendee
	0, // [0:5] is the sub-list for field type_name
}

func init() { file_domain_scenario_proto_init() }
func file_domain_scenario_proto_init() {
	if File_domain_scenario_proto != nil {
		return
	}
	file_domain_iteration_proto_init()
	file_domain_artifact_proto_init()
	if !protoimpl.UnsafeEnabled {
		file_domain_scenario_proto_msgTypes[0].Exporter = func(v interface{}, i int) interface{} {
			switch v := v.(*Scenario); i {
			case 0:
				return &v.state
			case 1:
				return &v.sizeCache
			case 2:
				return &v.unknownFields
			default:
				return nil
			}
		}
	}
	type x struct{}
	out := protoimpl.TypeBuilder{
		File: protoimpl.DescBuilder{
			GoPackagePath: reflect.TypeOf(x{}).PkgPath(),
			RawDescriptor: file_domain_scenario_proto_rawDesc,
			NumEnums:      1,
			NumMessages:   1,
			NumExtensions: 0,
			NumServices:   0,
		},
		GoTypes:           file_domain_scenario_proto_goTypes,
		DependencyIndexes: file_domain_scenario_proto_depIdxs,
		EnumInfos:         file_domain_scenario_proto_enumTypes,
		MessageInfos:      file_domain_scenario_proto_msgTypes,
	}.Build()
	File_domain_scenario_proto = out.File
	file_domain_scenario_proto_rawDesc = nil
	file_domain_scenario_proto_goTypes = nil
	file_domain_scenario_proto_depIdxs = nil
}
